using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

namespace Mod
{
    public class CustomGlowBattery : MonoBehaviour
    {
        public bool Activated = false;
        public GameObject Glow = new GameObject("BatteryGlow");
        public Color32 Colour;
        public float TargetCharge = 95f;
        public Sprite GlowSprite;
        public LightSprite Light;

        public void UpdateGlow()
        {
            if (Activated == true)
            {
                Light.Brightness = 2f;
                Glow.GetComponent<SpriteRenderer>().color = Colour;
            }
            else if (Activated == false)
            {
                Light.Brightness = 0f;
                Glow.GetComponent<SpriteRenderer>().color = new Color32(0, 0, 0, 0);
            }
        }
        void Start()
        {
            Glow.transform.parent = gameObject.transform;
            Glow.transform.rotation = gameObject.transform.rotation;
            Glow.transform.localPosition = new Vector3(0f, 0f);
            Glow.transform.localScale = new Vector3(1f, 1f);

            var Sprite = Glow.GetOrAddComponent<SpriteRenderer>();
            Sprite.sprite = GlowSprite;
            Sprite.material = ModAPI.FindMaterial("VeryBright");
            Sprite.color = new Color32(0, 0, 0, 0);
            Sprite.sortingOrder = gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;

            Light = ModAPI.CreateLight(gameObject.transform, new Color32(Colour.r, Colour.g, Colour.b, 255), 3f, 0f);
            UpdateGlow();
        }
        void Use()
        {
            Activated = !Activated;
            UpdateGlow();
        }
        void Update()
        {
            if (Activated == true)
            {
                gameObject.GetComponent<PhysicalBehaviour>().Charge = TargetCharge;
            }
            else
            {
                gameObject.GetComponent<PhysicalBehaviour>().Charge = 0f;
            }
        }
    }
    public class NoTemperature : MonoBehaviour
    {
        public void Update()
        {
            gameObject.GetComponent<PhysicalBehaviour>().Temperature = 20f;
        }
    }
    public class FlashbangFlash : MonoBehaviour
    {
        public LightSprite ScreenLight;
        public void Start()
        {
            ScreenLight = ModAPI.CreateLight(transform, new Color(1f, 1f, 1f, 1));

            ScreenLight.Brightness = 75f;
            ScreenLight.Radius = 15f;
            ScreenLight.transform.SetParent(this.gameObject.transform);
        }
    }
    public class Freeze : MonoBehaviour
    {
        public void Update()
        {
            gameObject.GetComponent<PhysicalBehaviour>().Temperature = -1000000f;
        }
    }
    public class DarkMatter : MonoBehaviour
    {
        public LightSprite ScreenLight;
        public void Start()
        {
            ScreenLight = ModAPI.CreateLight(transform, new Color(1f, 1f, 1f, 1));

            ScreenLight.Brightness = -25f;
            ScreenLight.Radius = 2.5f;
            ScreenLight.transform.SetParent(this.gameObject.transform);
        }
    }
    public class BlackHole1 : MonoBehaviour
    {
        public LightSprite ScreenLight;
        public void Start()
        {
            ScreenLight = ModAPI.CreateLight(transform, new Color(1f, 1f, 1f, 1));

            ScreenLight.Brightness = -100f;
            ScreenLight.Radius = 2.25f;
            ScreenLight.transform.SetParent(this.gameObject.transform);
        }
    }
    public class BlackHole2 : MonoBehaviour
    {
        public LightSprite ScreenLight;
        public void Start()
        {
            ScreenLight = ModAPI.CreateLight(transform, new Color(1f, 0.53f, 0f, 1));

            ScreenLight.Brightness = 50f;
            ScreenLight.Radius = 3f;
            ScreenLight.transform.SetParent(this.gameObject.transform);
        }
    }
    class ShieldBehaviour : MonoBehaviour
    {
        private void Start()
        {
            this.renderer = gameObject.GetComponent<SpriteRenderer>();
            UpdateState();
        }
        void UpdateState()
        {
            if (this.Activated)
            {
                renderer.sortingLayerName = "Bottom";
                gameObject.layer = 10;
            }
            else
            {
                renderer.sortingLayerName = "Objects";
                gameObject.layer = LayerMask.NameToLayer("Objects");
            }
        }
        private void Use()
        {
            if (!base.enabled)
            {
                return;
            }
            this.SetActivated(!this.Activated);
        }
        private void SetActivated(bool activated)
        {
            this.Activated = activated;
            UpdateState();
        }

        public bool Activated = true;
        [SkipSerialisation]
        public SpriteRenderer renderer;
        [SkipSerialisation]
        public Sprite A;
        [SkipSerialisation]
        public Sprite B;
    }
    public class AfterSpawnBehaviour : MonoBehaviour
    {

    }
}